#include <QtGui>
#include "qoauth.h"

extern "C" {
#include <oauth.h>
}

qOAuth::qOAuth(QWidget* parent)
  : Ui::QOAuthMainWindow()
{
  setupUi(this);
  connect(pushButton, SIGNAL(clicked()), this, SLOT(do_request()));
  connect(actionQuit, SIGNAL(triggered()), this, SLOT(quit_triggered()));
}

qOAuth::~qOAuth()
{
  ;
}

void qOAuth::quit_triggered() 
{
  close();
}

void qOAuth::do_request() 
{
  char *req_url = NULL;
  char *reply = NULL;

  plainTextEdit->setPlainText("");

  QString oa_bu = lineEdit_URL->text();
  QString oa_ck = lineEdit_CK->text();
  QString oa_cs = lineEdit_CS->text();
  QString oa_tk = lineEdit_TK->text();
  QString oa_ts = lineEdit_TS->text();

  req_url = oauth_sign_url2(
    oa_bu.toAscii().data(),
    /* HTTP-POST args */ NULL, 
    /* OAUTH METHOD */ OA_HMAC,
    /* HTTP METHOD default = "GET" */ NULL,
    oa_ck.toAscii().data(),
    oa_cs.toAscii().data(),
    oa_tk.toAscii().data(),
    oa_ts.toAscii().data()
  );

  if (!req_url) {
    plainTextEdit->setPlainText(" INTERNAL ERROR - signing the URL.");
    return;
  }

  reply = oauth_http_get(req_url,NULL);
  free(req_url);

  if (!reply) {
    plainTextEdit->setPlainText(" INTERNAL ERROR - HTTP request failed.");
    return;
  }

  plainTextEdit->setPlainText(reply);

  free(reply);
}
